      program pdb2mask

      implicit none

      include 'params.f'

      integer i,j,k,l,nx,ny,nz,ngrid(3),orig(3),nat,nset,ntit,iargc,
     &     gvflen

      real x,y,z,cell(6),space(3),xx(maxat),yy(maxat),zz(maxat),
     &     dis,crit,crit2,xav(3)

      real*8 c(3,3),d(3),e(3)

      logical use,gvfisf

      character*80 sdum

      if(iargc().ne.2) then
         write(0,'(a,a)') 'Usage: pdb2mask atomradius in.map < in.pdb ',
     &        '> out.mask'
         write(0,*)
         write(0,'(a,a)') 'Generates a mask from "in.pdb" based on ',
     &        'the map parameters from "in.map".'
         write(0,'(a,a)') '"in.map" has to be x-plor formatted format',
     &        ' for now.'
         stop
      endif

      nset=0
      call getarg(1,sdum)
      read(sdum,*) crit
      crit2=crit**2
C----
C---- read coordinates from stdin
C----
      nat=0
 50   continue
      read(5,'(a80)',err=60,end=70) sdum
      if ((sdum(1:4).ne.'ATOM').and.(sdum(1:4).ne.'HETA')) goto 50
      nat=nat+1
      if (nat.gt.maxat) then
         write(0,'(a)') 'Error - MAXAT exceeded'
         stop
      endif
      read(sdum,1000) xx(nat),yy(nat),zz(nat)
      goto 50
 60   write(0,'(a)') 'error while reading stdin'
      stop
 70   continue
      if (nat.eq.0) then
         write(0,'(a)') 'unexpected end of file while reading stdin'
         stop
      endif
      write(0,'(a,i5)') 'Nr of atoms:',nat
 80   continue
C----
C---- calculate average positions
C----
      xav(1)=0.0
      xav(2)=0.0
      xav(3)=0.0
      do i=1,nat
         xav(1)=xav(1)+dble(xx(i))
         xav(2)=xav(2)+dble(yy(i))
         xav(3)=xav(3)+dble(zz(i))
      enddo
      xav(1)=xav(1)/dble(nat)
      xav(2)=xav(2)/dble(nat)
      xav(3)=xav(3)/dble(nat)
C----
C---- set up 3x3 covariance matrix
C----
      do i=1,3
         do j=1,3
            c(i,j)=0.0
         enddo
      enddo
      do i=1,nat
         c(1,1)=c(1,1)+(xx(i)-xav(1))*(xx(i)-xav(1))
         c(1,2)=c(1,2)+(xx(i)-xav(1))*(yy(i)-xav(2))
         c(1,3)=c(1,3)+(xx(i)-xav(1))*(zz(i)-xav(3))
         c(2,1)=c(2,1)+(yy(i)-xav(2))*(xx(i)-xav(1))
         c(2,2)=c(2,2)+(yy(i)-xav(2))*(yy(i)-xav(2))
         c(2,3)=c(2,3)+(yy(i)-xav(2))*(zz(i)-xav(3))
         c(3,1)=c(3,1)+(zz(i)-xav(3))*(xx(i)-xav(1))
         c(3,2)=c(3,2)+(zz(i)-xav(3))*(yy(i)-xav(2))
         c(3,3)=c(3,3)+(zz(i)-xav(3))*(zz(i)-xav(3))
      enddo
C---- 
C---- diagonalise
C---- 
      call ql77(3,c,d,e,3)
      write(6,'(3f12.5)') c(1,3),c(2,3),c(3,3)
      write(0,'(a,3f10.3)') 'Eigenvalues:',d(1),d(2),d(3)
      write(0,'(a,3f10.3)') 'Principal axis:',c(1,3),c(2,3),c(3,3)
C----
C---- read map header
C----
      call getarg(2,sdum)
      call readxplormapheader(sdum,cell,nx,ny,nz,space,orig,ngrid)
C----
C---- go through entire map and determine which grid points to use
C----
      do k=1,nz
         do j=1,ny
            do i=1,nx
               use=.false.
               x=real(i+orig(1)-1)*space(1)
               y=real(j+orig(2)-1)*space(2)
               z=real(k+orig(3)-1)*space(3)
               do l=1,nat
                  dis=(xx(l)-x)**2
                  dis=dis+(yy(l)-y)**2
                  dis=dis+(zz(l)-z)**2
                  if (dis.lt.crit2) use=.true.
               enddo
               if (use) then
                  nset=nset+1
                  write (6,'(3i5)') i,j,k
               endif
            enddo
         enddo
      enddo

      write(0,'(a,i5)') 'Nr of mask points set:',nset

 1000 format (30x,3f8.3)

      end

